@use "sass:map";
@use "@angular/material" as mat;
@use "../../../../themes/mpa-theme.scss" as mpa;

$color-config: mat.m2-get-color-config(mpa.$mpa-theme);
$primary-palette: map.get($color-config, "primary");
$accent-palette: map.get($color-config, "accent");
$warn-palette: map.get($color-config, "warn");

// SELECTION MIXINS
@mixin mpa-selection-hover {
    &:hover {
        background-color: mat.m2-get-color-from-palette(
            $accent-palette,
            100
        ) !important;
    }
}

@mixin mpa-selection-background {
    background-color: mat.m2-get-color-from-palette(
        $accent-palette,
        100
    ) !important;
}


// WARN MIXINS
@mixin warn-border-and-font($border-hue:300, $font-hue: 300) {
    border-color: mat.m2-get-color-from-palette(
        $warn-palette,
        $border-hue
    );
    color: mat.m2-get-color-from-palette(
        $warn-palette,
        $font-hue
    )
}

@mixin warn-background-and-font-hover($background-hue: 600, $border-hue: 600) {
    &:hover {
        background-color: mat.m2-get-color-from-palette(
            $warn-palette,
            600
        );
        border-color: mat.m2-get-color-from-palette(
        $warn-palette,
        600
        );
        color: white;
    }
}

// SUBMIT BUTTON MIXINS
@mixin submit-background-and-font($border-hue: 400, $font-hue: 400, $font-weight: 500) {
    border-color: mat.m2-get-color-from-palette(
        $accent-palette,
        $border-hue
    );
    color: mat.m2-get-color-from-palette(
        $accent-palette,
        $font-hue
    );
    font-weight: $font-weight;
}

@mixin submit-background-and-font-hover($background-hue: 300, $font-color: white) {
    &:hover {
        background-color: mat.m2-get-color-from-palette(
            $accent-palette,
            $background-hue
        );
        color: $font-color;
    }
}

// GENERAL USE MIXINS
@mixin mpa-button-border {
    border-width: 2px;
    border-radius: 5px;
    border-style: solid;
}

@mixin mpa-primary-background-and-border-color($background-hue: 50, $border-hue: 50) {
    background-color: mat.m2-get-color-from-palette(
        $primary-palette,
        $background-hue
    );
    border-color: mat.m2-get-color-from-palette(
        $primary-palette,
        $border-hue
    );
}

@mixin mpa-accent-background-and-border-color($hue: 100,$border-hue: 100) {
    background-color: mat.m2-get-color-from-palette(
        $accent-palette,
        $hue
    );
    border-color: mat.m2-get-color-from-palette(
        $accent-palette,
        $border-hue
    );
}
